unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, ComCtrls, Jpeg, ImgList, Unit2, Unit3, Contnrs,
  Grids, Math;

type
  PTBitmap = ^TBitmap;
  TImageRecord = class(TObject)
    Original: TBitmap;
    Standard: TBitmap;
    Small: TBitmap;
    Current: PTBitmap;
    filename: string;
    suffix: string;
    constructor Create;
    destructor Destroy; override;
  end;
  TForm1 = class(TForm)
    PaintPanel: TPanel;
    Status: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    LoadImages1: TMenuItem;
    Saveallimages1: TMenuItem;
    SaveHTML1: TMenuItem;
    Functions1: TMenuItem;
    CreateThumbnails1: TMenuItem;
    Createstandardsized1: TMenuItem;
    Options1: TMenuItem;
    Preferences1: TMenuItem;
    ListPanel: TPanel;
    Splitter1: TSplitter;
    HTMLPanel: TPanel;
    Splitter2: TSplitter;
    HTML: TMemo;
    OpenImagesDialog: TOpenDialog;
    CreateHTML1: TMenuItem;
    ListMenu: TPopupMenu;
    Remove1: TMenuItem;
    Show1: TMenuItem;
    ImageListBox: TListBox;
    Original1: TMenuItem;
    Standard1: TMenuItem;
    Small1: TMenuItem;
    SaveDialog: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    ImageBox: TPaintBox;
    ThumbDrawGrid: TDrawGrid;
    procedure LoadImages1Click(Sender: TObject);
    procedure ImageListBoxClick(Sender: TObject);
    procedure ImageBoxPaint(Sender: TObject);
    procedure Original1Click(Sender: TObject);
    procedure Standard1Click(Sender: TObject);
    procedure Small1Click(Sender: TObject);
    procedure Remove1Click(Sender: TObject);
    procedure CreateThumbnails1Click(Sender: TObject);
    procedure Preferences1Click(Sender: TObject);
    procedure Createstandardsized1Click(Sender: TObject);
    procedure CreateHTML1Click(Sender: TObject);
    procedure Saveallimages1Click(Sender: TObject);
    procedure SaveHTML1Click(Sender: TObject);
    procedure ThumbDrawGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ThumbDrawGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure TabSheet2Show(Sender: TObject);
  private
    Images:TObjectList;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

//--------------------------------------------------------GETWIDTH/HEIGHT
function GetHeight(width:integer;Bitmap:TBitmap):integer;
begin
  GetHeight:=round(width/Bitmap.Width*Bitmap.Height);
end;

function GetWidth(height:integer;Bitmap:TBitmap):integer;
begin
  GetWidth:=round(height/Bitmap.Height*Bitmap.Width);
end;

function ExtractName(path:string):string;
begin
  ExtractName:=Copy(path,LastDelimiter('\',path)+1,Length(path)-LastDelimiter('\',path));
end;

function ExtractPath(path:string):string;
begin
  ExtractPath:=Copy(path,0,LastDelimiter('\',path));
end;

function ExtractType(filename:string):string;
begin
  ExtractType:=Copy(filename,LastDelimiter('.',filename)+1,Length(filename)-LastDelimiter('.',filename));
end;

function ExtractSansType(filename:string):string;
begin
  ExtractSansType:=Copy(filename,0,LastDelimiter('.',filename)-1);
end;

//--------------------------------------------------------IMAGE RECORD
constructor TImageRecord.Create;
begin
  inherited Create;
  Original:=TBitmap.Create;
  Standard:=nil;
  Small:=nil;
  Current:=@Original;
end;

destructor TImageRecord.Destroy;
begin
  Original.Free;
  Standard.Free;
  Small.Free;
  Current:=nil;
  inherited Destroy;
end;


{$R *.dfm}

//--------------------------------------------------------FORM EVENTS

procedure TForm1.LoadImages1Click(Sender: TObject);
var
  i:integer;
  tempJpeg:TJPEGImage;
  tempRecord:TImageRecord;
begin
  Images:=TObjectList.Create;

  if OpenImagesDialog.Execute then
  begin
    LoadingForm.Show;
    LoadingForm.ProgressBar.Position:=0;
    LoadingForm.Repaint;

    tempJpeg:=TJPEGImage.Create;
    try
      for i:=0 to OpenImagesDialog.Files.Count-1 do
      begin
        ImageListBox.Items.Add(ExtractSansType(ExtractName(OpenImagesDialog.Files.Strings[i])));
        tempJpeg.LoadFromFile(OpenImagesDialog.Files.Strings[i]);

        tempRecord:=TImageRecord.Create;
        with tempRecord do
        begin
          with Original do
          begin
            Width:=tempJpeg.Width;
            Height:=tempJpeg.Height;
            Canvas.Draw(0,0,tempJpeg);
          end;
          Small:=nil;
          Standard:=nil;
          filename:=ExtractSansType(ExtractName(OpenImagesDialog.Files.Strings[i]));
          suffix:=ExtractType(ExtractName(OpenImagesDialog.Files.Strings[i]));
        end;
        Images.Add(tempRecord);

        LoadingForm.ProgressBar.Position:=round(i/(OpenImagesDialog.Files.Count-1)*100);
      end;
    finally
      LoadingForm.ProgressBar.Position:=100;
      tempJpeg.Free;
      LoadingForm.Hide;
    end;
  end;
end;

procedure TForm1.ImageListBoxClick(Sender: TObject);
begin
  with ImageBox do
  begin
    Width:=TImageRecord(Images.Items[ImageListBox.ItemIndex]).Current^.Width;
    Height:=TImageRecord(Images.Items[ImageListBox.ItemIndex]).Current^.Height;
    Repaint;
  end;
end;

procedure TForm1.ImageBoxPaint(Sender: TObject);
begin
  if ImageListBox.ItemIndex<>-1 then
    ImageBox.Canvas.Draw(0,0,TImageRecord(Images.Items[ImageListBox.ItemIndex]).Current^);
end;

procedure TForm1.Original1Click(Sender: TObject);
begin
  TImageRecord(Images.Items[ImageListBox.ItemIndex]).Current:=
    @(TImageRecord(Images.Items[ImageListBox.ItemIndex]).Original);
  ImageBox.Repaint;
end;

procedure TForm1.Standard1Click(Sender: TObject);
begin
  if(TImageRecord(Images.Items[ImageListBox.ItemIndex]).Standard<>nil) then
    TImageRecord(Images.Items[ImageListBox.ItemIndex]).Current:=
      @(TImageRecord(Images.Items[ImageListBox.ItemIndex]).Standard)
  else ShowMessage('Standard sized image not yet created!');
  ImageBox.Repaint;
end;

procedure TForm1.Small1Click(Sender: TObject);
begin
  if(TImageRecord(Images.Items[ImageListBox.ItemIndex]).Small<>nil) then
    TImageRecord(Images.Items[ImageListBox.ItemIndex]).Current:=
      @(TImageRecord(Images.Items[ImageListBox.ItemIndex]).Small)
  else ShowMessage('Small image not yet created!');
  ImageBox.Repaint;
end;

procedure TForm1.Remove1Click(Sender: TObject);
begin
  Images.Delete(ImageListBox.ItemIndex);
  ImageListBox.Items.Delete(ImageListBox.ItemIndex);
  ThumbDrawGrid.Refresh();
  ThumbDrawGrid.Repaint();
end;

procedure TForm1.CreateThumbnails1Click(Sender: TObject);
var
  i:Integer;
begin
  LoadingForm.Show;
  LoadingForm.ProgressBar.Position:=0;
  LoadingForm.Repaint;
  for i:=0 to Images.Count-1 do
  begin
    with TImageRecord(Images.Items[i]) do
    begin
      Small:=TBitmap.Create;
      if PreferencesForm.xCheck.Checked then
      begin
        Small.Width:=StrToInt(PreferencesForm.thumbwidth.Text);
        Small.Height:=GetHeight(Small.Width,Original);
        Small.Canvas.StretchDraw(Rect(0,0,Small.Width,Small.Height),Original);
      end
      else
      begin
        Small.Height:=StrToInt(PreferencesForm.thumbheight.Text);
        Small.Width:=GetWidth(Small.Height,Original);
        Small.Canvas.StretchDraw(Rect(0,0,Small.Width,Small.Height),Original);
      end;
    end;
  end;
  LoadingForm.Hide;
end;

procedure TForm1.Preferences1Click(Sender: TObject);
begin
  PreferencesForm.ShowModal;
end;

procedure TForm1.Createstandardsized1Click(Sender: TObject);
var
  i:Integer;
begin
  LoadingForm.Show;
  LoadingForm.ProgressBar.Position:=0;
  LoadingForm.Repaint;
  for i:=0 to Images.Count-1 do
  begin
    with TImageRecord(Images.Items[i]) do
    begin
      Standard:=TBitmap.Create;
      if PreferencesForm.xCheck.Checked then
      begin
        Standard.Width:=StrToInt(PreferencesForm.standardwidth.Text);
        Standard.Height:=GetHeight(Standard.Width,Original);
        Standard.Canvas.StretchDraw(Rect(0,0,Standard.Width,Standard.Height),Original);
      end
      else
      begin
        Standard.Height:=StrToInt(PreferencesForm.standardheight.Text);
        Standard.Width:=GetWidth(Standard.Height,Original);
        Standard.Canvas.StretchDraw(Rect(0,0,Standard.Width,Standard.Height),Original);
      end;
    end;
  end;
  LoadingForm.Hide;
end;

procedure TForm1.CreateHTML1Click(Sender: TObject);
var
  i:integer;
  temp:string;
begin
  LoadingForm.Show;
  LoadingForm.ProgressBar.Position:=0;
  LoadingForm.Repaint;
  for i:=0 to Images.Count-1 do
  begin
    with TImageRecord(Images.Items[i]) do
    begin
      temp:=Preferencesform.HTMLformat.Text;
      temp:=StringReplace(temp,'ORIGINAL',filename+'.'+suffix,[rfReplaceAll]);
      temp:=StringReplace(temp,'STANDARD',filename+Preferencesform.standardsuffix.Text+'.'+suffix,[rfReplaceAll]);
      temp:=StringReplace(temp,'SMALL',filename+Preferencesform.thumbsuffix.Text+'.'+suffix,[rfReplaceAll]);
      temp:=StringReplace(temp,'NAME',filename,[rfReplaceAll]);
      HTML.Lines.Add(temp);
    end;
  end;
  LoadingForm.Hide;
end;

procedure TForm1.Saveallimages1Click(Sender: TObject);
var
  i:integer;
  tempJpeg:TJPEGImage;
  path:string;
begin
  if SaveDialog.Execute then
  begin
    LoadingForm.Show;
    LoadingForm.ProgressBar.Position:=0;
    LoadingForm.Repaint;

    path:=ExtractPath(SaveDialog.FileName);

    tempJpeg:=TJPEGImage.Create;
    with tempJpeg do
    begin
      ProgressiveEncoding:=PreferencesForm.progressive.checked;
      Smoothing:=PreferencesForm.smoothing.checked;
      CompressionQuality:=PreferencesForm.compressqual.position;
    end;

    try
      for i:=0 to Images.Count-1 do
      begin
        with TImageRecord(Images.Items[i]) do
        begin
          with tempJpeg do
          begin
            Assign(Original);
            SaveToFile(path+filename+'.'+suffix);
            if (Small=nil) or (Standard=nil) then
                ShowMessage('Small and/or Standard Size of "'+filename+'" not yet created. Not saving.')
            else
            begin
              Assign(Standard);
              SaveToFile(path+filename+PreferencesForm.standardsuffix.Text+'.'+suffix);
              Assign(Small);
              SaveToFile(path+filename+PreferencesForm.thumbsuffix.Text+'.'+suffix);
            end;
          end;
        end;
      end;
    finally
      tempJpeg.Free;
      LoadingForm.Hide;
    end;
  end;
end;

procedure TForm1.SaveHTML1Click(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    HTML.Lines.SaveToFile(SaveDialog.FileName);
  end;
end;

procedure TForm1.ThumbDrawGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
  if (Images<>nil) and (Images.Count>Acol+ARow*ThumbDrawGrid.ColCount) then
  begin
    with TImageRecord(Images.Items[Acol+ARow*ThumbDrawGrid.ColCount]) do
    begin
      if (Small=nil)  then
        ThumbDrawGrid.Canvas.TextOut(Rect.Left,Rect.Top,'No thumbnail available for '+filename+'.')
      else
      begin
        ThumbDrawGrid.Canvas.Draw(Rect.Left,Rect.Top,Small);
        ThumbDrawGrid.Canvas.TextOut(Rect.Left,Rect.Top+Small.Height,filename)
      end;
    end;
  end;
end;

procedure TForm1.ThumbDrawGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  ImageListBox.ItemIndex:=ACol+ARow*ThumbDrawGrid.ColCount;
end;

procedure TForm1.TabSheet2Show(Sender: TObject);
begin
  ThumbDrawGrid.DefaultColWidth:=StrToInt(PreferencesForm.thumbwidth.Text);
  ThumbDrawGrid.DefaultRowHeight:=StrToInt(PreferencesForm.thumbheight.Text)+50;
  ThumbDrawGrid.ColCount:=floor(ThumbDrawGrid.Width/StrToInt(PreferencesForm.thumbwidth.Text));
  ThumbDrawGrid.RowCount:=ceil(Images.Count/ThumbDrawGrid.ColCount);
end;

end.
